/***************************************************************************
 *** news_articles.pike
 ***
 *** based on news_articles.cpp from Fred, <fred@ceylana.com>
 *** ported to pike by Niels van Sluis, <n.vansluis@amc.nl>
 *** Tue Aug 13 2002, newsobjects-0.9.3
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define false 	0
#define	true	1

class news_articles {
  string class_id = "news_articles";

  private object head;
  private object needle;
  private object tail;

  void create() {
    news_articles();
  }

  void news_articles() {
  }

  int addArticle(object article) {
  //
  // Add a news_article object to the collection.
  //
   
    if(!head) {
      head = .std_dataobject.std_dataobject();
      head->data = article;
      needle = head;
      tail = head;
    } else {
      needle->next = .std_dataobject.std_dataobject();
      needle->next->prev = needle;
      needle = needle->next;
      needle->data = article;
      tail = needle;
    }

    return true;
  }

  object getArticle() {
  //
  // Returns a news_article from the top of the collection and removes it from
  // the collection.
  //

    object temp = head->data;
    if(head->next) head = head->next;
    return temp;
  }

  int count() {
  //
  // Returns the number of news_article objects in the collection.
  //
    int count = 0;

    needle = head;
    while(needle->next) {
      count++;
      needle = needle->next;
    }
    return count;
  }

  int isEmpty() {
  // 
  // Returns true if there are no news_article objects in the collection.
  //

    if(!head->next) return true;
    return false;
  }

  int saveHeaders(string path) {
  //
  // Save the list of headers to a file indicated by path.
  //

    string temp;
    object file;
 
    file = Stdio.FILE();
    file->open(path,"CW");

    needle = head;
    while(needle->next) {
      file->write("%d\t",(int)needle->data->getNumber());
      file->write("%s\t",needle->data->getSubject());
      file->write("%s\t",needle->data->getFrom());
      object date = needle->data->getDate();
      temp = date->rfcOutput();
      file->write("%s\t",temp);
      file->write("%s\t",needle->data->getId());
      file->write("%s\t",needle->data->getReferences());
      file->write("%d\t",(int)needle->data->getBytes());
      file->write("%d\t",(int)needle->data->getLines());
      file->write("\n");

      needle = needle->next;
    }

    file->write("%d\t",(int)needle->data->getNumber());
    file->write("%s\t",needle->data->getSubject());
    file->write("%s\t",needle->data->getFrom());
    object date = needle->data->getDate();
    temp = date->rfcOutput();
    file->write("%s\t",temp);
    file->write("%s\t",needle->data->getId());
    file->write("%s\t",needle->data->getReferences());
    file->write("%d\t",(int)needle->data->getBytes());
    file->write("%d\t",(int)needle->data->getLines());
    file->write("\n");


    file->close();
    return true;
  }

  int loadHeaders(string path) {
  //
  // Load saved headers from a file indicated by path.  Returns false if the
  // file does not exist or cannot be accessed.
  //

    object file;

    if(!file->open(path,"R")) {
      destruct(file);
      return false;
    }
    
    object tempart;
    while(string temp = file->gets()) {
      tempart = .news_article.news_article();
      tempart->init(temp);
      addArticle(tempart); 
    }

    return true;
  }
};
