/***************************************************************************
 *** news_date.pmod - based on news_date.cpp from Fred, <fred@ceylana.com>
 ***                  ported to pike by Niels van Sluis, <n.vansluis@amc.nl>
 ***                  Tue Aug 15 2002, newsobjects-0.9.3
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define false 	0
#define	true	1

class news_date {
  string class_id = "news_date";
  private int psecond;
  private int pminute;
  private int phour;
  private int pday;
  private int pmonth;
  private int pyear;
  private string pzone;

  void create(void|string date) {
    news_date(date);
  }

  void news_date(void|string date) {
    if(stringp(date)) {
    //
    // news_date(string date);
    //
    // This constructor takes a string formated as an rfc822 date and
    // parses it.
    //

      string month;

      if(sscanf(date,"%*s, %d %s %d %d:%d:%d %s",pday, month, pyear, phour,
                                                 pminute, psecond, pzone) == 8);
      if(sscanf(date,"%d %s %d %d:%d:%d %s", pday, month, pyear, phour,
                                             pminute, psecond, pzone) == 7);
      setMonth(month);

      return;
    }

    if(!stringp(date)) {
    //
    // news_date();
    //
     
      setNow();
      return;
    }
  }

  int setZone(string zone) {
  //
  // Sets the time zone via a free form string.
  //

    pzone = zone;
    return true;
  }

  int getDay() {
  //
  // Returns the day as an integer between 1 and 31.
  //

    return pday;
  }

  int getMonth() {
  //
  // Returns the month as an integer between 1 and 12.
  //

    return pmonth;
  }

  int getYear() {
  // 
  // Returns the year as a four digit integer.
  //

    return pyear;
  }

  int getHour() {
  //
  // Returns the hour as an integer between 0 and 24.
  //

    return phour;
  }

  int getMinute() {
  //
  // Returns the minute as an integer between 1 and 59.
  //

    return pminute;
  }

  int getSecond() {
  //
  // Returns the second as an integer betweem 1 and 59.
  //

    return psecond;
  }

  string getZone() {
  // 
  // Returns the time zone as a free form string.
  //

    return pzone;
  }

  int setDay(int day) {
  //
  // Set the day of the month using an integer.
  //

    if (day < 1 || day < 31) return false;
    pday = day;
    return true;
  }

  int setMonth(string|int a) {
    if(stringp(a)) { 
    //
    // setMonth(string month);
    //
    // Set the month using a string of the from Jan, Feb, etc or January,
    // February, etc.
    //

      string month = a;

      switch(month) {
        case "Jan" : 
        case "January"  : setMonth(1);  break;
        case "Feb" :
        case "February" : setMonth(2);  break;
        case "Mar" :
        case "March"    : setMonth(3);  break;
        case "Apr" :
        case "April"    : setMonth(4);  break;
        case "May"      : setMonth(5);  break;
        case "Jun" :
        case "June"     : setMonth(6);  break;
        case "Jul" :
        case "July"     : setMonth(7);  break;
        case "Aug" :
        case "August"   : setMonth(8);  break;
        case "Sep" :
        case "September": setMonth(9);  break;
        case "Oct" :
        case "October"  : setMonth(10); break;
        case "Nov" : 
        case "November" : setMonth(11); break;
        case "Dec" :
        case "December" : setMonth(12); break;

        default : return false;
      }
      return true;
    }

    if(intp(a)) {
    //
    // setMonth(int month);
    //
    // Set the month using an integer.
    //

      int month = a;
 
      if (month < 1 || month > 12) return false;
      pmonth = month;
      return true;
    }
  }

  int setYear(int year) {
  //
  // Set the year using an integer.
  //

    if (year < 1960 || year > 2999) return false;
    pyear = year;
    return true;
  }

  int setHour(int hour) {
  //
  // Set the hour.
  //

    if(hour < 0 || hour > 24) return false;
    phour = hour;
    return true;
  }

  int setMinute(int minute) {
  // 
  // Set the minute.
  //

    if(minute < 0 || minute > 59) return false;
    pminute = minute;
    return true;
  }

  int setSecond(int second) {
  //
  // Set the seconds.
  //

    if(second < 0 || second > 59) return false;
    psecond = second;
    return true;
  }

  int setNow() {
  //
  // Sets the time and date to the current time and date.
  //

    mapping timeinfo = localtime(time());
    setDay(timeinfo["mday"]);
    setHour(timeinfo["hour"]);
    setMinute(timeinfo["min"]);
    setMonth(timeinfo["mon" + 1]);
    setSecond(timeinfo["sec"]);
    setYear(timeinfo["year"] + 1900);

    return true;
  }

  string rfcOutput() {
  //
  // Output a string date formatted to rfc 822 specs.
  //

    string stemp = "";
    if (getDay() < 10) stemp+="0"; 
    stemp += getDay() + " ";
    stemp += getMonthStringA() + " ";
    stemp += getYear() + " ";
    if (getHour() < 10) stemp += "0";
    stemp += getHour() + " ";
    if (getMinute() < 10) stemp += "0";
    stemp += getMinute() + ":";
    if (getSecond() < 10) stemp += "0";
    stemp += getSecond() + " ";
    stemp += getZone();

    return stemp;
  }

  string getMonthStringA() {
  //
  // Returns a string with the abbreviated month such as Jan, Feb...
  //

    if (pmonth == 1)  return "Jan";
    if (pmonth == 2)  return "Feb";
    if (pmonth == 3)  return "Mar";
    if (pmonth == 4)  return "Apr";
    if (pmonth == 5)  return "May";
    if (pmonth == 6)  return "Jun";
    if (pmonth == 7)  return "Jul";
    if (pmonth == 8)  return "Aug";
    if (pmonth == 9)  return "Sep";
    if (pmonth == 10) return "Oct";
    if (pmonth == 11) return "Nov";
    if (pmonth == 12) return "Dec";
    return "Error";
  }

  string getMonthString() {
  //
  // Returns the month as a string, for example January, February...
  //

    if (pmonth == 1)  return "January";
    if (pmonth == 2)  return "February";
    if (pmonth == 3)  return "March";
    if (pmonth == 4)  return "April";
    if (pmonth == 5)  return "May";
    if (pmonth == 6)  return "June";
    if (pmonth == 7)  return "July";
    if (pmonth == 8)  return "August";
    if (pmonth == 9)  return "September";
    if (pmonth == 10) return "October";
    if (pmonth == 11) return "November";
    if (pmonth == 12) return "December";
    return "Error";
  }

  string getNewOutput() {
  //
  // Returns a string in the format required by the newnews and newgroups
  // commands.
  //

    string stemp;
        // write this func
    stemp = "";
    return stemp;
  }
};
