/***************************************************************************
 *** news_group.pmod - based on news_group.cpp from Fred, <fred@ceylana.com>
 ***                   ported to pike by Niels van Sluis,<n.vansluis@amc.nl>
 ***                   Tue Aug 15 2002, newsobjects-0.9.3
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define false 	0
#define	true	1

class news_group {
  string class_id = "news_group";
  private string pname;
  private int pfirst;
  private int plast;
  private int psubscribed;
  private int punsubscribed;
  private string pdescription;
  private string pfounder;
  private string pfounded;

  void create(void|string name, void|int first, void|int last) {
    news_group(name,first,last);
  }

  void news_group(void|string name, void|int first, void|int last) {
    if(stringp(name) && intp(first) && intp(last)) {
    //
    // news_group(string name, int first, int last);
    //
    // This constructor takes the name as a string and the first and last
    // article number as ints.
    // 

      setName(name);
      setFirst(first);
      setLast(last);
      
      return;
    }

    if(stringp(name) && !first) { 
    //
    // news_group(string temp);
    //
    // This constructor expects a string formatted exactly like a line
    // outputted from the list command.
    //

      string tname, tfirst, tlast;
      sscanf(name,"%s %s %s %*s", tname,tfirst,tlast);
      setName(tname);
      setFirst((int)tfirst);
      setLast((int)tlast);

      return;
    }
  }

  int subscribe() {
  //
  // Subscribe to the group.
  //

    psubscribed = true;
    return true;
  }

  int unsubscribe() {
  // 
  // Unsubscribe from the group.
  //

    punsubscribed = false;
    return true;
  }

  int isSubscribed() {
  //
  // Returns true if the group is subscribed, false otherwise.
  //

    return psubscribed;
  }

  int setName(string name) {
  //
  // Set the name of the group to string.
  //

    pname = name;
    return true;
  }

  int setFirst(int first) {
  //
  // Set the first article number to int.
  //

    pfirst = first;
    return true;
  }

  int setLast(int last) {
  //
  // Set the last article number to int
  //

    plast = last;
    return true;
  }

  string getName() {
  //
  // returns group name as string.
  //

    return pname;
  }

  int getFirst() {
  //
  // Returns first article number as int.
  //

    return pfirst;
  }

  int getLast() {
  //
  // Returns last article number as int.
  //

    return plast;
  }

  int setDescription(string description) {
  //
  // Set the description of the group to string
  //

    pdescription = description;
    return true;
  }

  int setFounder(string founder) {
  //
  // Set the founder of the group to string.
  //

    pfounder = founder;
    return true;
  }

  int setFounded(string founded) {
  //
  // Set the founded date to free from string - no date format yet.
  //

    pfounded = founded;
    return true;
  }

  string getDescription() {
  //
  // Returns group description as string.
  //

    return pdescription;
  }

  int getTotal() {
  //
  // Returns estimated total article count as int.
  //

    if(plast - pfirst > 0) {
      return ( plast - pfirst );
    } else {
      return 0;
    }
  }

  int isEmpty() {
  //
  // Returns true if there are no current articles in group.
  //

    if(plast - pfirst < 1) {
      return true;
    } else {
      return false;
    }
  }

  string getFounder() {
  //
  // Returns group founder as string.
  //

    return pfounder;
  }

  string getFounded() {
  //
  // Returns founded date as string.
  //

    return pfounded;
  }

  int init(string temp) {
  //
  // This function takes a string formatted from the list command and sets
  // the members.
  //

    string tname, tfirst, tlast;
    if(sscanf(temp,"%s %s %s %*s", tname,tlast,tfirst) == 4) {
      setName(tname);
      setFirst((int)tfirst);
      setLast((int)tlast);
    }
    return true;
  }

};
