/***************************************************************************
 *** news_groups.pike
 ***
 *** based on news_groups.cpp from Fred, <fred@ceylana.com>
 *** ported to pike by Niels van Sluis, <n.vansluis@amc.nl>
 *** Tue Aug 15 2002, newsobjects-0.9.3
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define false 	0
#define	true	1

class news_groups {
  string class_id = "news_groups";

  private object head;
  private object needle;
  private object tail;

  void create() {
    news_groups();
  }

  void news_groups() {
  }

  int addGroup(object group) {
  //
  // Add a news_group object to the news_groups container.
  //

    if(!head) {
      head = .std_dataobject.std_dataobject();
      head->data = group;
      needle = head;
      tail = head;
    } else {
      needle->next = .std_dataobject.std_dataobject();
      needle->next->prev = needle;
      needle = needle->next;
      needle->data = group;
      tail = needle;
    }

    return true;
  }

  object getGroup() {
  //
  // Returns a group from the top of the container and removes it from the
  // container.
  //

    object temp = head->data;
    if(head->next) head = head->next; 
    return temp;
  }

  int count() {
  //
  // Returns the number of news_groups in the container as an int.
  //
    int count = 0;

    needle = head;
    while(needle->next) {
      count++;
      needle = needle->next;
    }
    return count;
  }

  int isEmpty() {
  //
  // Returns true if there are no news_group objects in the container.
  //
    if(!head->next) {
      return true;
    }
    return false;
  }

  int saveGroups(string path) {
  //
  // Save the list of news_groups to a file.
  //

    object file;
  
    file = Stdio.FILE();
    file->open(path,"cw");

    needle = head;
    while(needle->next) {
      file->write("%s ",needle->data->getName());
      file->write("%d ",needle->data->getLast());
      file->write("%d ",needle->data->getFirst());
      file->write("\n");
      needle = needle->next;
    }

    file->write("%s ",needle->data->getName());
    file->write("%d ",needle->data->getLast());
    file->write("%d ",needle->data->getFirst());
    file->write("\n");

    file->close();
    return true;
  }

  int loadGroups(string path) {
  //
  // Load news_group objects from file indicated by path.
  //

    object file;
    
    if(!file->open(path,"R")) {
      destruct(file);
      return false;
    }
    
    object tempgroup;
    while(string temp = file->gets()) {
      tempgroup = .news_group.news_group();
      tempgroup->init(temp);
      addGroup(tempgroup); 
    }
 
    return true;
  }
};
