/***************************************************************************
 *** std_connection.pike
 ***
 *** based on std_connection.cpp from Fred, <fred@ceylana.com>
 *** ported to pike by Niels van Sluis, <n.vansluis@amc.nl>
 *** Tue Aug 15 2002, newsobjects-0.9.3
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define false 	0
#define	true	1

class std_connection {
  string class_id = "std_connection";
  private string pstatus;
  private string perror;
  private string phost;
  private int pport;
  private object psocket_fd = Stdio.FILE();

  void create(void|string a, void|int b) {
    std_connection(a,b);
  }

  void destroy() {
    if(pstatus == "Connected") {
      psocket_fd->close();
      pstatus = "Disconnected";
    }
  }

  void std_connection(void|string a, void|int b) {
    if(stringp(a) && intp(b)) {
    //
    // std_connection(string host, int port);
    //

      string host = a;
      int port = b;

      pstatus = "Not Connected";
      perror = "No Error";
      phost = resolve(host);
      makeAddress();
      makeConnection();
      return;
    }

    //
    // std_connection();
    //
    pstatus = "Not Connected";
    perror = "No Error";
    pport = 0;
  }

  int setHost(string host) {
  //
  // Set the server host using a string containing a fully qualified domain
  // name or an ip address in dot quad notation.
  //

    phost = host;
    return true;
  }

  string getHost() {
  //
  // Returns the server ip address in dot quad notation.
  //

    return phost;
  }
  
  int setPort(int port) {
  // 
  // Set the server port number using an integer.
  //

    pport = port;
    return true;
  }

  int getPort() {
  //
  // Return the server port number as an integer.
  //

    return pport;
  }

  string resolve(string hostname) {
    /* pike has no need for resolving hostname */
    pstatus = "Resolving Hostname";
    phost = hostname; 
  }

  int makeAddress() {
    /* pike has no need for making address structure */
    return true;
  }

  int makeConnection() {
  //
  // Internal function for making the connection.
  //

    if(!psocket_fd->open_socket()) {
      perror = "Create Socket failed";
      return false;
    } 
    if(!psocket_fd->connect(phost,pport)) {
      werror("%s %d",phost,pport);
      perror = "Connection failed";
      return false;
    }
    pstatus = "Connected";
    return true;
  }

  string getStatus() {
  //
  // Returns a string containing the connection status.
  //

    return pstatus;
  }

  string getError() {
  //
  // Returns a string containing the last error message if any.
  //

    return perror;
  }

  int send(string text) {
  //
  // Sends the text to the remote server.
  //

    if(psocket_fd->write(text)) return true;
    else return false;
  }

  string receive() {
  //
  // Returns a string containing the text received from the remote server
  // one line at a time.
  //

    return psocket_fd->gets() +"\n";
  }

  int isConnected() {
  //
  // Returns true if connected to the remote server.
  //

    if(pstatus == "Connected") return true;
    return false;
  }

  int disconnect() {
  //
  // Closes the connection to the remote server.
  //
    psocket_fd->close();
    destruct(psocket_fd);
    pstatus = "Disconnected";
    return true;
  }

  int connectHost() {
  //
  // Connect to the remote host. Returns 1 on success.
  // Returns 2 if there is no host specified.
  // Returns 3 if there is no port specified.
  // Returns 4 if there already is an active connection.
  //

    if(pstatus == "Connected") return 4;
    if(phost == "") return 2;
    if(pport == 0) return 3;
    makeAddress();
    makeConnection();
    return 1;
  }

  void setError(string error) {
  //
  // Set the error message.
  //

    perror = error;
  }
};
